import java.util.*;

public class Hanoi {

    private final static int NUMBER_OF_TOWERS = 3; // ̖{

    private final static int START = 0;  // Jn
    private final static int END = 1;    // I
    private final static int VIA = 2;    // oR

    private int size;                    // ̃TCY
    private Player player;

    public Hanoi(int size){
        this.size = size;
        
        player = new Player();
    }

    // Q[̃C[`
    public void startGame(){
        List towers = makeTowers();

        System.out.println("nmC̓");
        printTowers(towers);
        System.out.println(START + "  " + END + " ֈړĂ\n");

        do{
            PileMovementInfo pileMovementInfo;
            try{
                pileMovementInfo = player.nextStep(towers);
            }catch(GiveUpException ex){
                // Give Up
                solve(makeTowers(), size, START, END, VIA);
                return;
            }

            movePile(towers, pileMovementInfo.getSource(), pileMovementInfo.getDestination());
            printTowers(towers);
        }while(!checkCompletion(towers, END));

        System.out.println("܂\n߂łƂ܂");
    }

    // nmC̓
    private List solve(List towers, int n, int start, int end, int via){
        if(n > 0){
            // n-1 oRɈړ
            towers = solve(towers, n-1, start, via, end);
            
            // n ڂړI̓Ɉړ
            movePile(towers, start, end);
            System.out.println("Move " + start + " to " + end);
            printTowers(towers);

            try{
                Thread.sleep(500);
            }catch(InterruptedException e){}

            // n-1 oRړI̓Ɉړ
            towers = solve(towers, n - 1, via, end, start);
        }
        return towers;
    }

    // ~Ղ̈ړ
    private void movePile(List towers, int source, int destination){
        Stack tower = (Stack)towers.get(source);
        Integer diameter = (Integer)tower.pop();
        tower = (Stack)towers.get(destination);
        tower.push(diameter);
    }

    // nmC̓̐
    private List makeTowers(){
        List towers = new ArrayList();

        for(int i = 0 ; i < NUMBER_OF_TOWERS ; i++){
            towers.add(new Stack());
        }

        for(int i = size ; i > 0 ; i--){
            ((Stack)towers.get(START)).push(new Integer(i));
        }

        return towers;
    }
        
    // I`FbN
    private boolean checkCompletion(List towers, int goal){
        // ړ̓̉~Ղ̖~Ղ̑ƓłΊ
        Stack tower = (Stack)towers.get(goal);
        if(tower.size() == size){
            return true;
        }else{
            return false;
        }
    }

    // nmC̓̕`
    private void printTowers(List towers){
        System.out.println("");

        // Stack 𑀍삷邽߂ɃN[
        List tempTowers = new ArrayList();
        for(int i = 0 ; i < NUMBER_OF_TOWERS ; i++){
            tempTowers.add(((Stack)towers.get(i)).clone());
        }
            
        for(int i = size ; i > 0 ; i--){
            for(int j = 0 ; j < NUMBER_OF_TOWERS ; j++){
                Stack tower = (Stack)tempTowers.get(j);
                if(tower.size() >= i){
                    // ̈ԏɂĂ~Ղ`
                    Integer diameter = (Integer)tower.pop();
                    printPile(diameter.intValue());
                }else{
                    printPole();
                }

                System.out.print("  ");
            }
            System.out.println("");
        }

        printBase();
    }

    // ~Ղ`
    private void printPile(int diameter){
        for(int i = 0 ; i < size - diameter ; i++){
            System.out.print(" ");
        }
        for(int i = 0 ; i < 2*diameter -1 ; i++){
            System.out.print("*");
        }
        for(int i = 0 ; i < size - diameter ; i++){
            System.out.print(" ");
        }
    }

    // `
    private void printPole(){
        for(int i = 0 ; i < size-1 ; i++){
            System.out.print(" ");
        }
        System.out.print("|");
        for(int i = 0 ; i < size-1 ; i++){
            System.out.print(" ");
        }
    }

    // ̔ԍ`
    private void printPoleNumber(int num){
        for(int i = 0 ; i < size-1 ; i++){
            System.out.print(" ");
        }
        System.out.print(num);
        for(int i = 0 ; i < size-1 ; i++){
            System.out.print(" ");
        }
    }

    // ̕`
    private void printBase(){
        for(int i = 0 ; i < NUMBER_OF_TOWERS ; i++){
            for(int j = 0 ; j < 2 * size - 1 ; j++){
                System.out.print("~");
            }
            System.out.print("  ");
        }
        System.out.println("");

        for(int i = 0 ; i < NUMBER_OF_TOWERS ; i++){
            printPoleNumber(i);
            System.out.print("  ");
        }
        System.out.println("\n");
    }

    public static void main(String[] args){
        if(args.length < 1){
            System.out.println("Usage: java Hanoi [~Ղ̖]");
            return;
        }

        Hanoi hanoi = new Hanoi(Integer.parseInt(args[0]));
        hanoi.startGame();
    }
}
